//cut point reid for rootstock plant
#pragma once
#include <time.h>
#include <opencv.hpp>
#include "data_def_api.h"
#include "data_def.h"
#include "logger.h"
#include "imstorage_manager.h"

//using namespace cv;
namespace graft_cv{

class CRootStockCutPointReid{
public:
	CRootStockCutPointReid(ConfigParam&c,CGcvLogger*pLog=0);
	~CRootStockCutPointReid();
	int cut_point_reid(			//киʶ
		ImgInfo*,				//кͼƬ
		cv::Mat&,					//кͼƬ
		const char * pre_img_id,		//ǰͼid
		PositionInfo& posinfo,	
		map<string, cv::Mat>& img_cache
		);	
	void set_image_saver(CImStoreManager** ppis){m_ppImgSaver=ppis;}
private:
	cv::Mat m_preGrayImg;// gray image
	//Mat m_binImg;// binary image
	cv::Mat m_grayImg;// gray image
	cv::Mat m_edgeImg;
	string m_imgId;
	CImStoreManager** m_ppImgSaver;

	//ͼƬڵ
	ImgInfo* m_pImginfoBinFork;//fork-y, right-x
	ImgInfo* m_pImgCorners;//corners, reference-point, candidate box
	ImgInfo* m_pImgCutPoint;//reference-point, cutpoint


	//global configure parameters
	ConfigParam& m_cparam;
	CGcvLogger * m_pLogger;
	// image segment
	void img_preprocess(cv::Mat&);
	void clear_imginfo();
	
};

// ѿиʶ
// кʶ
class CSolaCutPointReid {
public:
	CSolaCutPointReid(ConfigParam&c, int stemType=0, CGcvLogger*pLog=0);
	~CSolaCutPointReid();
	int cut_point_reid(			//киʶ
		ImgInfo*,				//кͼƬ
		cv::Mat&,					//кͼƬ		
		PositionInfo& posinfo
	);
	void set_image_saver(CImStoreManager** ppis) { m_ppImgSaver = ppis; }
private:
	int m_stem_type; //ֲ0--磻1--ľ
					 //global configure parameters
	ConfigParam& m_cparam;
	CGcvLogger * m_pLogger;
	string m_imgId;
	CImStoreManager** m_ppImgSaver;
	cv::Mat m_grayImg;// gray image
	cv::Mat m_binImg; // bin image

	//ͼƬڵ
	ImgInfo* m_pImginfoBin;//	
	ImgInfo* m_pImgCutPoint;//reference-point, cutpoint

	void clear_imginfo();
	inline string get_stem_type_name();
	void img_preprocess(cv::Mat&img);
	void find_cut_curve(vector<cv::Point>&points,
		vector<cv::Point>&cut_curve,
		cv::RotatedRect& retval);
	void find_cut_ys(vector<cv::Point>&points,
		int&minx, int& maxx,
		int&miny, int&maxy,
		int&cut_miny, int&cut_midy, int&cut_maxy
	);
};
};