#pragma once
#include <opencv.hpp>
#include <map>
#include <opencv2\imgproc\imgproc.hpp>
#include "data_def_api.h"
#include "logger.h"
#include "imstorage_manager.h"

using namespace std;
//using namespace cv;

namespace graft_cv{

// class COptimalAngle
// 1. find the max angle 
// 2. find the clamp position
// ͼ0ȵ180ȼ䣬һ֡Ϊ0ʱ̣һ֡Ϊ180ʱ
// õķƴݣ360ȷΧͨҵС㣬
//             ϣõԳx꣬ΪŽǶ
//class COptimalAngle
//{
//public:
//	COptimalAngle(ConfigParam&, CGcvLogger* pLog=0);
//	virtual ~COptimalAngle(void);
//	int reset();
//	int append(ImgInfo*, 
//		PositionInfo& posinfo
//		);
//	double infer(PositionInfo& posinfo);// calculate the optimal angle
//
//	//fit optimal angle based m_an2width
//	virtual double angle_fit(map<int, int>&,bool is_base=false);
//	virtual double angle_fit_base(map<int, int>&);// for base matter
//	void set_image_saver(CImStoreManager** ppis)
//	{
//		m_ppImgSaver=ppis;
//	}
//protected:
//	//global configure parameters
//	ConfigParam& m_cparam;
//	CGcvLogger* m_pLogger;
//	string m_patch_id;
//	CImStoreManager** m_ppImgSaver;
//	int m_imgIndex;
//	string m_imgId;
//   
//	// binary image
//	Mat m_binImg;
//	Mat m_binImgBase;
//
//	//ͼƬڵ
//	ImgInfo* m_pImginfo;
//	ImgInfo* m_pImginfoBase;
//
//	// Ƕ-Ҷչȣأ
//	map<int, int> m_an2width;
//	map<int, int> m_an2widthBase;
//	// ͼ
//	// min_idxxmax_idxҲx
//	int imgproc(
//		Mat&,  
//		vector<int>& hist, 
//		int& min_idx, 
//		int& max_idx);
//	int imgprocBase(
//		Mat&,  
//		vector<int>& hist, 
//		int& min_idx, 
//		int& max_idx);
//
//	// ͷm_pImginfo
//	void clear_imginfo();
//	    
//	//ֲyֵϵ
//	vector<int> m_fork_ys;
//	
//	//͵yֵϵ
//	vector<int> m_end_ys;
//
//	//Ҷչϵ
//	vector<int>m_widths;
//
//	//all image size
//	int m_width;
//	int m_height;	
//};


//COptimalAnglePart, ̳COptimalAngle
//ͼ0ȵ90ȼ䣬֤>=90ȷΧ
//0-90ȷΧȻֵСֵͨСֲֵ
//      ֵϣõǶȼ
//class COptimalAnglePart: public COptimalAngle{
//public:
//	COptimalAnglePart(ConfigParam&, CGcvLogger*pLog=0);
//	virtual ~COptimalAnglePart();
//	//fit optimal angle based m_an2width
//	double angle_fit(map<int, int>&,bool is_base=false);
//	double angle_fit_base(map<int, int>&);// for base matter
//protected:
//	//zero_cross_detect()
//	//⣬ȷǷ񵥵ֲСֲ
//	//ؾֲֵindex
//	void zero_cross_detect(
//		vector<int>&d_sign, //input
//		bool& is_local_max, // whether exists local max 
//		int& local_limit_idx // local limit index of original vector
//		);  
//	double limit_min_angle(
//		vector<double>&x, //sorted, ascending
//		vector<double>&y,
//		size_t min_idx
//		);
//
//	// y = k1*x + b1y = k2*x + b2ֱཻ㣬x
//	double line_cross(
//		double k1,
//		double b1,
//		double k2,
//		double b2);
//	//
//	double opt_angle_part_impl(
//		vector<double>&x, //sorted, ascending
//		vector<double>&y,
//		bool is_base=false);
//};

// CCotyledonAngle
// ľͨҶǶʶṩתǶ
class CCotyledonAngle{
public:

	CCotyledonAngle(ConfigParam&, CGcvLogger* pLog=0);
	virtual ~CCotyledonAngle();
	int angle_recognize(ImgInfo*, 
		PositionInfo& posinfo
		);
	void set_image_saver(CImStoreManager** ppis)
	{
		m_ppImgSaver=ppis;
	}

protected:
	//global configure parameters
	ConfigParam& m_cparam;
	CGcvLogger* m_pLogger;

	string m_imgId;
	CImStoreManager** m_ppImgSaver;


	//all image size
	cv::Mat m_grayImg;
	cv::Mat m_binImg;
	int m_width;
	int m_height;
	cv::Mat m_openImg; // for save	

	//ͼƬڵ
	ImgInfo* m_pImginfoOpen;//fork-y, right-x
	ImgInfo* m_pImginfoAngle;//corners, reference-point, candidate box
	

	//
	typedef struct {
		double area;
		double centx;
		double centy;		
		cv::RotatedRect minrect_ellips;
		vector<cv::Point> contours;
	} t_leaf;

	void img_segment(cv::Mat&img);
	double fit_error_ellipse(cv::RotatedRect&ellipse_rect,vector<cv::Point>& pts);
	void get_ellipse_param(cv::RotatedRect&ellipse_rect,   //input
		float&A, float&B, float&C, float&F); //output
	void clear_imginfo();
};

};
